const nconf = require('nconf');

const CONFIG_DIR = `config`
let config_file;

switch(process.env.NODE_ENV) {
    case 'development':
        config_file = `${CONFIG_DIR}/config.json`;
        break;
    case 'test':
        config_file = `${CONFIG_DIR}/test_config.json`;
        break;
    case 'production':
        config_file = `${CONFIG_DIR}/config.json`;
        break;
}

// Exports the config.json as an object with get functions
nconf.argv()
    .env()
    .file({ file: `${process.cwd()}/${config_file}` });

module.exports = nconf;
