const mongoose = require('mongoose')

const libs = `${process.cwd()}/libs`;
const config = require(`${libs}/config`);
const log = require(`${libs}/log`)(module);

const Schema = mongoose.Schema;

// Should define this somewhere else
const MAX_SIMULATION_TIME = 10;


let SimulationSchema = new Schema({
    name: {
        type: String,
        required: true,
    },
    location: Object,
    time: Number,
    failure_rate: Array,
    goals_care: Array,
    goals_inclusion: Array,
});

SimulationSchema.methods.setTime = function (t) {
    t = parseInt(t, 10);
    if (!t || t > MAX_SIMULATION_TIME) {
        // Throw an error?
        return;
    }
    this.time = t;
};
SimulationSchema.methods.setLocation = function (l) {
    // Should sanitize
    this.location = l;
};
SimulationSchema.methods.setFailureRate = function (fr) {
    // Should sanitize
    this.failure_rate = fr;
};
SimulationSchema.methods.setCareGoals = function (g) {
    // Should sanitize
    this.goals_care = g;
};
SimulationSchema.methods.setInclusionGoals = function (g) {
    // Should sanitize
    this.goals_inclusion = g;
};
SimulationSchema.methods.update = function (property, value) {
    if (property === 'time') this.setTime(value);
    if (property === 'location') this.setLocation(value);
    if (property === 'failure_rate') this.setFailureRate(value);
    if (property === 'goals_care') this.setCareGoals(value);
    if (property === 'goals_inclusion') this.setInclusionGoals(value);
};

SimulationSchema.methods.run = function () {
    /* Runs the Simulation with given parameters */
    // if (!this.name || !this.location || !this.time) {
    //     console.log('This is supposed to be an error.');
    // }
};

module.exports = mongoose.model('Simulation', SimulationSchema);
